function [ x, s, t, A1opt, A2opt, Iopt, sum_act, avg_inact, time, k, kd, uds, pift, apifu, mpifu, pft, apfu, mpfu, mcountpp] = ckr_box( Q, d, a, b, cA, A1start, A2start, tol,sil)

% solves: min q'x + (1/2) x'Qx  subject to: x  <= b
% Q is assumed to be symmetric positive definite
tic;
n = length(d);                  % problem size
done = 0;                   % not yet done
countpp = 0;
mcountpp = 0;
uds = 0;
pift = 0;
pft = 0;
apifu = 0;
apfu = 0;
mpifu = 0;
mpfu = 0;

if (cA == 1)
    s = -d - Q*b;
    s_old = s;
    t = zeros(n,1);
    t_old = t;
    err_d1 = log10(max(-min(s),1e-99));
    err_d2 = log10(1e-99);
    A1pre = 1:n;
    A1pre = A1pre';
    A2pre = [];
    Ipre = [];
    A1 = find(s>0);
    A2 = [];
    k = 0;
    kd = 1;
    sum_act = n;
    mfn = 0.5*b'*Q*b+b'*d;
else
    A1 = A1start;
    A2 = A2start;
    t = zeros(n,1);
    s = zeros(n,1);
    k = 0; 
    kd = 0;
    sum_act = 0;
    mfn = 10^50;
end

avg_inact = 0;
delta = 0;
x_h = b;
x = b;
Q_act = Q;
d_act = d;
N = 1:n;

while done < 1;                  % while not optimal
     A1 = sort(A1);
     A2 = sort(A2);
     k = k + 1;                  % start a new iteration
     I = ones(n,1);              % compute I, the complement of A
     I(A1) = zeros(length(A1),1); 
     I(A2) = zeros(length(A2),1);
     I = find(I>0);              % complement of A
     I = sort(I);
% solve system KKT(A):
     avg_inact = avg_inact + length(I);
     x_old = x;
     I = sort(I);
     x = zeros(n,1);                      % x( A) = b( A); 
     x(A1) = b(A1);
     x(A2) = a(A2);
     if isempty(I) == 0;          
         rhs = -d_act(I);
         if isempty(A1) == 0;       % update right hand side rhs
           rhs = rhs - Q_act(I,A1)*b(A1);   
         end; 	   
         if isempty(A2) == 0;       % update right hand side rhs
           rhs = rhs - Q_act(I,A2)*a(A2);   
         end; 	
         x(I) = Q_act(I,I) \ rhs;
     end
     err = log10(max(norm(Q*x+d+s+t,1),1e-99));
     err_p1 = log10(max(max(x-b),1e-99));
     err_p2 = log10(max(max(a-x),1e-99));
    x_h_old = x_h;
    x_h = min(x,b);
    x_h = max(x_h,a);
    mfn_old = mfn;
    mfn_old = mfn_old+abs(mfn_old/10^15);
    mfn = 0.5*x_h'*Q*x_h + d'*x_h;
    if(sil ~= 1)
        delmf = mfn - mfn_old;
    end
    cid = 0;
    x_0 = b;
    x_0(I) = x(I);
       if(mfn_old < mfn)   
           countpp = countpp + 1;
           if(countpp <= 50)
            if(sil ~= 1)
                fprintf('Output1: %3.0d %6.0f %10.2f %10.2f %10.2f %10.2f  %10.2f    %+2.2e     %10.2f \n',[k  length(I)  err_p1  err_p2   err_d1   err_d2   err   delmf    delta]);
            end
                delta = full(max(max(Q(I,I))))/5;
                cid = 1;
                x(I) = 1/(1+delta)*(delta*x_old(I)+x_0(I));
                err = log10(max(norm(Q*x+d+s+t,1),1e-99));
                err_p1 = log10(max(max(x-b),1e-99));
                err_p2 = log10(max(max(a-x),1e-99));
                x_h = min(x,b);
                x_h = max(x_h,a);
                mfn = 0.5*x_h'*Q*x_h + d'*x_h;
                if(sil ~= 1)
                    delmf = mfn - mfn_old;
                    fprintf('Output2: %3.0d %6.0f %10.2f %10.2f  %10.2f %10.2f  %10.2f    %+2.2e     %10.2f \n',[k  length(I)  err_p1   err_p2   err_d1   err_d2   err   delmf    delta]);
                end
                while((mfn_old <= mfn || (err_p1 < -90 && err_p2 < -90)) && cid <= 6)
                    if(err_p1 > -90 || err_p2 > -90)
                        delta = cid*delta*n^(1/3);
                    else
                        delta = cid*delta/n^(1/3);
                    end
                    cid = cid + 1;
                    x(I) = 1/(1+delta)*(delta*x_old(I)+x_0(I));
                    err = log10(max(norm(Q*x+d+s+t,1),1e-99));
                    err_p1 = log10(max(max(x-b),1e-99));
                    err_p2 = log10(max(max(a-x),1e-99));
                    x_h = min(x,b);
                    x_h = max(x_h,a);	
                    mfn = 0.5*x_h'*Q*x_h + d'*x_h;
                    if(sil ~= 1)
                        delmf = mfn - mfn_old;
                        fprintf('Output3: %3.0d %6.0f %10.2f %10.2f %10.2f %10.2f %10.2f    %+2.2e     %10.2f \n',[k  length(I)  err_p1   err_p2   err_d1   err_d2   err   delmf    delta]);
                    end
                end
           end
                if(mfn_old <= mfn || (err_p1 < -90  && err_p2 < -90))
                    countpp = 0;
                    if(log10(max(max(x_old-b),1e-99)) > -90  ||  log10(max(max(a-x_old),1e-99)) > -90)
                        %fprintf('First part of safeguard entered. Part infeasible \n');
                        pift = pift + 1;
                        pifu = 1;
                        A1(N) = 1;
                        A1(x_old<b) = 0;
                        A1 = find(A1>0);
                        A1 = sort(A1);
                        A2(N) = 1;
                        A2(x_old>a) = 0;
                        A2 = find(A2>0);
                        A2 = sort(A2);
                        I = ones(n,1);              % compute I, the complement of A
                        I(A1) = zeros(length(A1),1); 
                        I(A2) = zeros(length(A2),1); 
                        I = find(I>0);              % complement of A
                        I = sort(I);
                        k = k + 1;
                        avg_inact = avg_inact + length(I);
                        delta = 0;
                        Q_act = Q;
                        d_act = d;
                        x = zeros(n,1);                      % x( A) = b( A); 
                         x(A1) = b(A1);
                         x(A2) = a(A2);
                         if isempty(I) == 0;          
                             rhs = -d_act(I);
                             if isempty(A1) == 0;       % update right hand side rhs
                               rhs = rhs - Q_act(I,A1)*b(A1);   
                             end; 	   
                             if isempty(A2) == 0;       % update right hand side rhs
                               rhs = rhs - Q_act(I,A2)*a(A2);   
                             end; 	
                             x(I) = Q_act(I,I) \ rhs;
                         end
                        x_h = min(x,b);
                        x_h = max(x_h,a);
                        mfn = 0.5*x_h'*Q*x_h + d'*x_h;
                        if(sil ~= 1)
                            delmf = mfn - mfn_old;
                             err = log10(max(norm(Q*x+d+s+t,1),1e-99));
                             err_p1 = log10(max(max(x-b),1e-99));
                             err_p2 = log10(max(max(a-x),1e-99));
                            fprintf('Output4: %3.0d %6.0f %10.2f %10.2f %10.2f %10.2f  %10.2f    %+2.2e     %10.2f \n',[k  length(I)  err_p1  err_p2  err_d1  err_d2   err   delmf    delta]);
                        end
                        inner_count = 1;
                        err_p1 = 0;
                        err_p2 = 0;
                        x_0 = b;
                        x_0(I) = x(I);
                        x_0(A2) = a(A2);
                        while(mfn_old <= mfn || (err_p1 < -90  && err_p2 < -90))
                            pifu = pifu + 1;
                            if(inner_count == 1)
                                IJind1 = ones(n,1);
                                IJind2 = ones(n,1);
                                IJind1(b-x_h_old == 0) = 0;
                                IJind2(a-x_h_old == 0) = 0;
                                IJind1 = find(IJind1 > 0);
                                IJind1 = sort(IJind1);
                                emax1 = max(-1./(b(IJind1)-x_h_old(IJind1)).*(x_h_old(IJind1)-x(IJind1)));
                                IJind2 = find(IJind2 > 0);
                                IJind2 = sort(IJind2);
                                emax2 = max(1./(x_h_old(IJind2)-a(IJind2)).*(x_h_old(IJind2)-x(IJind2)));
                                emax = max(emax1,emax2);
                                upper_bound = emax;
                                lower_bound = 0;
                            else
                                if(err_p1 < -90 && err_p2 < -90)
                                    upper_bound = delta; 
                                else
                                    lower_bound = delta;
                                end 
                            end
                            inner_count = inner_count + 1;
                            delta = (upper_bound+lower_bound)/2;
                            x(I) = 1/(1+delta)*(delta*x_old(I)+x_0(I));
                            x_h = min(x,b);
                            x_h = max(x_h,a);
                            mfn = 0.5*x_h'*Q*x_h + d'*x_h;
                            err_p1 = log10(max(max(x-b),1e-99));
                            err_p2 = log10(max(max(a-x),1e-99));
                            if(sil ~= 1)
                                delmf = mfn - mfn_old;
                                err = log10(max(norm(Q*x+d+s+t,1),1e-99));
                                fprintf('Output5: %3.0d %6.0f %10.2f %10.2f %10.2f %10.2f  %10.2f    %+2.2e     %10.10f \n',[k  length(I)  err_p1  err_p2   err_d1   err_d2   err   delmf    delta]);
                            end
                        end
                        mpifu = max(mpifu,pifu);
                        apifu = apifu + pifu;
                    else
                        %fprintf('Second part of safeguard entered. Part feasible \n');
                        pft = pft + 1;
                        pfu = 1;
                        [dummy1,help1] = min(s_old);
                        [dummy2,help2] = max(t_old);
                        if(abs(dummy1) > abs(dummy2))
                            A1 = setdiff(Apre1,help1);
                            A2 = Apre2;
                            I = [Ipre;help1];
                        else
                            A1 = Apre1;
                            A2 = setdiff(Apre2,help2);
                            I = [Ipre;help2];
                        end
                        I = sort(I);
                        k = k + 1;
                        avg_inact = avg_inact + length(I);
                        delta = 0;
                        Q_act = Q;
                        d_act = d;
                        x = zeros(n,1);                      % x( A) = b( A); 
                         x(A1) = b(A1);
                         x(A2) = a(A2);
                         if isempty(I) == 0;          
                             rhs = -d_act(I);
                             if isempty(A1) == 0;       % update right hand side rhs
                               rhs = rhs - Q_act(I,A1)*b(A1);   
                             end; 	   
                             if isempty(A2) == 0;       % update right hand side rhs
                               rhs = rhs - Q_act(I,A2)*a(A2);   
                             end; 	
                             x(I) = Q_act(I,I) \ rhs;
                         end
                        x_h = min(x,b);
                        x_h = max(x_h,a);
                        mfn = 0.5*x_h'*Q*x_h + d'*x_h;
                        err_p1 = log10(max(max(x-b),1e-99));
                        err_p2 = log10(max(max(a-x),1e-99));
                        if(sil ~= 1)
                            delmf = mfn - mfn_old;
                            err = log10(max(norm(Q*x+d+s+t,1),1e-99));
                            fprintf('Output6: %3.0d %6.0f %10.2f %10.2f %10.2f %10.2f %10.2f    %+2.2e     %10.2f \n',[k  length(I)  err_p1  err_p2   err_d1   err_d2   err   delmf    delta]);
                        end
                        err_p1 = 0;
                        err_p2 = 0;
                        inner_count = 1;
                        x_0 = b;
                        x_0(I) = x(I);
                        x_0(A2) = a(A2);
                        while(mfn_old <= mfn || (err_p1 < -90  && err_p2 < -90))
                            pfu = pfu + 1;
                            if(inner_count == 1)
                                IJind1 = ones(n,1);
                                IJind2 = ones(n,1);
                                IJind1(b-x_h_old == 0) = 0;
                                IJind2(a-x_h_old == 0) = 0;
                                IJind1 = find(IJind1 > 0);
                                IJind1 = sort(IJind1);
                                emax1 = max(-1./(b(IJind1)-x_h_old(IJind1)).*(x_h_old(IJind1)-x(IJind1)));
                                IJind2 = find(IJind2 > 0);
                                IJind2 = sort(IJind2);
                                emax2 = max(1./(x_h_old(IJind2)-a(IJind2)).*(x_h_old(IJind2)-x(IJind2)));
                                emax = max(emax1,emax2);
                                upper_bound = emax;
                                lower_bound = 0;
                            else
                                if(err_p1 < -90 && err_p2 < -90)
                                    upper_bound = delta; 
                                else
                                    lower_bound = delta;
                                end 
                            end
                            inner_count = inner_count + 1;
                            delta = (upper_bound+lower_bound)/2;
                            x(I) = 1/(1+delta)*(delta*x_old(I)+x_0(I));
                            err_p1 = log10(max(max(x-b),1e-99));
                            err_p2 = log10(max(max(a-x),1e-99));
                            x_h = min(x,b);
                            x_h = max(x_h,a);
                            mfn = 0.5*x_h'*Q*x_h + d'*x_h;
                            if(sil ~= 1)
                                delmf = mfn - mfn_old;
                                err = log10(max(norm(Q*x+d+s+t,1),1e-99));
                                fprintf('Output7: %3.0d %6.0f %10.2f %10.2f %10.2f %10.2f  %10.2f    %+2.2e     %10.2f \n',[k  length(I)  err_p1  err_p2   err_d1   err_d2   err   delmf    delta]);
                            end      
                        end 
                        mpfu = max(mpfu,pfu);
                        apfu = apfu + pfu;
                    end
                end
       else
           countpp = 0;
       end
       mcountpp = max(countpp,mcountpp);
       if(sil ~= 1)
           delmf = mfn - mfn_old;
       end
       
        uds = uds + cid + 1;
        s = zeros(n,1);            % s( I) = 0
        t = zeros(n,1);
        kd = kd + 1;
        if isempty(A1) == 0;            % backsubsitute for s(A), if |A|>0 
            s(A1) = -d(A1) - Q(A1,:)*x;
            sum_act = sum_act + length(A1);
        end;
        if isempty(A2) == 0;            % backsubsitute for s(A), if |A|>0 
            t(A2) = -d(A2) - Q(A2,:)*x;
            sum_act = sum_act + length(A2);
        end;
        err_p1 = log10(max(max(x-b),1e-99));
        err_p2 = log10(max(max(a-x),1e-99));
        err_d1 = log10(max(-min(s),1e-99));
        err_d2 = log10(max(max(t),1e-99));
        err = log10(max(norm(Q*x+d+s+t,1),1e-99));
        Apre1 = A1;
        Apre2 = A2;
        Ipre = I;
        s_old = s;
        t_old = t;
        delta = 0;  
        if(sil ~= 1)
            fprintf('Output8: %3.0d %6.0f %10.2f %10.2f %10.2f %10.2f  %10.2f    %+2.2e     %10.2f   %6.0f \n',[k  length(I)  err_p1  err_p2   err_d1   err_d2   err   delmf    delta    countpp]);
        end
        A1 = zeros(n,1);
        A1(N) = 1;
        A1(s<0) = 0;
        A1(x<b) = 0;
        A1 = find(A1>0);
        A1 = sort(A1);
        A2 = zeros(n,1);
        A2(N) = 1;
        A2(t>0) = 0;
        A2(x>a) = 0;
        A2 = find(A2>0);
        A2 = sort(A2);
        Q_act = Q;
        d_act = d;

        done = max(x-b)<=tol & max(a-x) <= tol & min(s)>= -tol  & max(t) <= tol; 
        
     if k > 1000; done = 1;       % emergency exit to avoid cycling
         if(sil == 0)
            fprintf('max number of iterations reached. \n');
         end
     end;
end;                 % end while
time = toc;
A1opt = A1;
A2opt = A2;
Iopt = I;
if(sil ~= 1)
optobj = 0.5*x'*Q*x+d'*x;
fprintf('The optimal objective value is %+2.2e. \n', optobj); 
fprintf('%4.3f seconds needed to find the optimal objecitve value.  \n', time);
end
if(k == 0)
    uds = 0;
else
    uds = uds/k;
end
if(cA == 1)
    avg_inact = avg_inact/(k+1);
else
    avg_inact = avg_inact/k;
end








