function [] = gen_sprand_box_constraint(n,density,runs,cond,choose)

% initialize variables for output
anoi_kr = 0;
atime_kr = 0;
inact_var_kr = 0;
cyc_kr = 0;
anoi_hr = 0;
atime_hr = 0;
anoi_mat = 0;
atime_mat = 0;
inact_var_hr = 0;
allmaxfloor = 0;
atotal = 0;
arel_err = 0;
anoi_ckr = 0;
atime_ckr = 0;
arel_err_ckr = 0;
aprimup = 0;
adualup = 0;
aheuiter = 0;
maxp = 0;
inact_var_ckr = 0;
fprintf('\n Parameters \n');
fprintf(' n    runs  density cond \n');
fprintf('%d  %d    %3.3f  %1.1e\n',n,runs,density,cond);

for i = 1:runs

    % generate data
    Q = sprandsym(n,density,1/(cond*5),2);
    x = randn(n,1);
    Qx = Q*x;
    [dummy,ind] = sort(Qx);
    q = -Qx;
    q(ind(1:n/4)) = -q(ind(1:n/4));
    q(ind(3*n/4:end)) = q(ind(3*n/4:end));
    b = 1000*ones(n,1);
    a = -0.2*ones(n,1);
    b(Qx<0) = 0;
    
    if(choose(1) == 1)
        % call KR-Algorithm
        solvetime = tic;
        %fprintf('\n\n KR-Algorithm\n');
        [x,alpha,beta, iter, avg_inact] = kr_box( Q, q, a, b, 1:n, [], 10^-10, 1);
        kr_time = toc(solvetime);
        if (iter > 200)
                cyc_kr = cyc_kr + 1;
        else
                anoi_kr = anoi_kr + iter;
                atime_kr = atime_kr + kr_time;
                inact_var_kr = inact_var_kr + avg_inact;
        end
    end

    if(choose(2) == 1)
        % call mKR-Algorithm
        solvetime = tic;
        %fprintf('\n\n Modified KR-Algorithm\n');
        [x, alpha, beta, Aopt1, Aopt2, dummy, iter, maxfloor, totalsolves, avginact] = mkr_box( Q, q, a, b, 1, [], [], [], [], 0, 10^-10, 0, 0, 0, 1);
        hr_time = toc(solvetime);
        anoi_hr = anoi_hr + iter;
        atotal = atotal + totalsolves;
        atime_hr = atime_hr + hr_time;
        inact_var_hr = inact_var_hr + avginact;
        allmaxfloor = max(allmaxfloor,maxfloor);
        obj_opt = 0.5*x'*Q*x+q'*x;
    end
    
    if(choose(3) == 1)
        solvetime = tic;
        [xopt, alpha, beta, A1opt, A2opt, Iopt, sum_act, avg_inact, time, oiter, kd, uds, pift, apifu, mpifu, pft, apfu, mpfu, mcountpp] = ckr_box( Q, q, a, b, 1, [], [], 10^-10, 1);
        ckr_time = toc(solvetime);
        atime_ckr = atime_ckr + ckr_time;
        aheuiter = aheuiter + uds;
        aprimup = aprimup + pift;
        adualup = adualup + pft;
        maxp = max(maxp,mcountpp);
        anoi_ckr = anoi_ckr + oiter;
        inact_var_ckr = inact_var_ckr + avg_inact;
        arel_err_ckr = arel_err_ckr + (0.5*xopt'*Q*xopt+q'*xopt-obj_opt)/abs(obj_opt);
    end
    
    
    if(choose(4) == 1)
        % call Reflective Trust-Region Method
        %fprintf('\n\n Matlabs Reflective Trust-Region Method\n');
        options = optimset('quadprog');
        options = optimset(options,'Display','off'); 
         solvetime = tic;
        [x,dummy1,dummy2,output] = quadprog(Q, q, [], [], [], [], a, b, [], options);
        anoi_mat = anoi_mat + output.iterations;
        matlab_time = toc(solvetime);
        atime_mat = atime_mat + matlab_time;
        arel_err = arel_err + (0.5*x'*Q*x+q'*x-obj_opt)/abs(obj_opt);
    end
end


if(choose(1) == 1)
    anoi_kr = anoi_kr/(runs-cyc_kr);
    atime_kr = atime_kr/(runs-cyc_kr);
    inact_var_kr = inact_var_kr/(runs-cyc_kr);
end


if(choose(2) == 1)
    anoi_hr = anoi_hr/runs;
    atime_hr = atime_hr/runs;
    inact_var_hr = inact_var_hr/runs;
    atotal = atotal/runs;
end

if(choose(3) == 1)
    anoi_ckr = anoi_ckr/runs;
    atime_ckr = atime_ckr/runs;
    arel_err_ckr = arel_err_ckr/runs;
    aheuiter = aheuiter/runs;
    adualup = adualup/runs;
    aprimup = aprimup/runs;
    inact_var_ckr = inact_var_ckr/runs;
end

if(choose(4) == 1)
    anoi_mat = anoi_mat/runs;
    atime_mat = atime_mat/runs;
    arel_err = arel_err/runs;
end

if(choose(1) == 1)
    fprintf('\n\n Kunisch-Rendl-Algorithm\n'); % display some info on screen 
    fprintf('  atime   anoi   kr_cyc  inact_var\n');        
    fprintf(' %3.2f   %3.2f   %4d    %3.2f \n\n',atime_kr,anoi_kr,cyc_kr,inact_var_kr);
end

if(choose(2) == 1)
    fprintf('\n\n modified Kunisch-Rendl-Algorithm\n'); % display some info on screen 
    fprintf('  atime   anoi   total_solves   mds   inact_var\n');        
    fprintf(' %3.2f   %3.2f   %3.2f    %4d   %3.2f \n\n',atime_hr,anoi_hr,atotal,allmaxfloor,inact_var_hr);
end

if(choose(3) == 1)
    fprintf('\n\n Controled Kunisch-Rendl-Algorithm\n'); % display some info on screen 
    fprintf('  atime   anoi  heuiter  primup   dualup   maxp   inact var  relative error\n');        
    fprintf(' %3.2f   %3.2f   %3.2f      %3.2f     %3.2f      %d     %3.2f    %10.10e \n\n',atime_ckr,anoi_ckr,aheuiter,aprimup,adualup,maxp,inact_var_ckr,arel_err_ckr);
end

if(choose(4) == 1)
    fprintf('\n\n Reflective Trust-Region\n'); % display some info on screen 
    fprintf('  atime   anoi   relative error\n');        
    fprintf(' %3.3f   %3.3f   %10.10e \n\n',atime_mat,anoi_mat,arel_err);
end
